//
//  main.cpp
//  06-Textures
//
//  Created by Orlando Pereira on 06/05/15.
//  Copyright (c) 2015 Orlando Pereira. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 
#include <GLUT/glut.h>

extern unsigned char image[];
extern int imageDepth;
extern int imageHeight;
extern int imageWidth;

float angle, tick1 = 0;

void animate(int value) {
    tick1 += 4 * (16 / 100.0);
    angle = ((int) tick1) % 360;
    glutPostRedisplay();
}

#define TIMEDELTA(dest, src1, src2) { \
if(((dest).tv_usec = (src1).tv_usec - (src2).tv_usec) < 0) {\
(dest).tv_usec += 1000000;\
(dest).tv_sec = (src1).tv_sec - (src2).tv_sec - 1;\
} else  (dest).tv_sec = (src1).tv_sec - (src2).tv_sec;  }

void renderCube(void) {
    
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glPushMatrix();
    
    glRotatef(angle, 0, 1, 0);
    glBegin(GL_QUADS);
    
    glVertex3f(-1.0, -1.0, 1.0);
    glVertex3f(1.0, -1.0, 1.0);
    glVertex3f(1.0, 1.0, 1.0);
    glVertex3f(-1.0, 1.0, 1.0);
    
    glVertex3f(-1.0, 1.0, -1.0);
    glVertex3f(1.0, 1.0, -1.0);
    glVertex3f(1.0, -1.0, -1.0);
    glVertex3f(-1.0, -1.0, -1.0);
    
    glVertex3f(-1.0, -1.0, -1.0);
    glVertex3f(-1.0, -1.0, 1.0);
    glVertex3f(-1.0, 1.0, 1.0);
    glVertex3f(-1.0, 1.0, -1.0);
    
    glVertex3f(1.0, 1.0, -1.0);
    glVertex3f(1.0, 1.0, 1.0);
    glVertex3f(1.0, -1.0, 1.0);
    glVertex3f(1.0, -1.0, -1.0);
    
    glEnd();
    
    glPopMatrix();
    glutSwapBuffers();

    glutTimerFunc(0, animate, 1);
}

static void keyboard(unsigned char key, int x, int y) {
    switch (key) {
        case 27:
            exit(0);
    }
}

int main(int argc, char **argv) {
    
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glutInitWindowSize(512, 512);
    glutCreateWindow("Cube Texture Mapping");
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(renderCube);
    glMatrixMode(GL_PROJECTION);
    gluPerspective(60.0, 1.0, 1.0, 100.0);
    
    glEnable(GL_CULL_FACE);
    
    glMatrixMode(GL_MODELVIEW);
    gluLookAt(0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.);

    // DEFINE THE TEXTURE HERE!
    
    
    animate(0);

    glutMainLoop();
    return 0;
}
